YieldTermStructure Class Referenceabstract
Term structures

Interest-rate term structure. More...

`#include <ql/termstructures/yieldtermstructure.hpp>`

Inheritance diagram for YieldTermStructure:
[legend]

## Public Member Functions

Constructors
See the TermStructure documentation for issues regarding constructors.
| YieldTermStructure (const DayCounter &dc=DayCounter())
| YieldTermStructure (const Date &referenceDate, const Calendar &cal=Calendar(), const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| YieldTermStructure (Natural settlementDays, const Calendar &cal, const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
QL_DEPRECATED | YieldTermStructure (const DayCounter &dc, const std::vector< Handle< Quote > > &jumps, const std::vector< Date > &jumpDates=std::vector< Date >())
Discount factors
These methods return the discount factor from a given date or time to the reference date. In the latter case, the time is calculated as a fraction of year from the reference date.
DiscountFactor | discount (const Date &d, bool extrapolate=false) const
DiscountFactor | discount (Time t, bool extrapolate=false) const
Zero-yield rates
These methods return the implied zero-yield rate for a given date or time. In the former case, the time is calculated as a fraction of year from the reference date.
InterestRate | zeroRate (const Date &d, const DayCounter &resultDayCounter, Compounding comp, Frequency freq=Annual, bool extrapolate=false) const
InterestRate | zeroRate (Time t, Compounding comp, Frequency freq=Annual, bool extrapolate=false) const
Forward rates
These methods returns the forward interest rate between two dates or times. In the former case, times are calculated as fractions of year from the reference date. If both dates (times) are equal the instantaneous forward rate is returned.
InterestRate | forwardRate (const Date &d1, const Date &d2, const DayCounter &resultDayCounter, Compounding comp, Frequency freq=Annual, bool extrapolate=false) const
InterestRate | forwardRate (const Date &d, const Period &p, const DayCounter &resultDayCounter, Compounding comp, Frequency freq=Annual, bool extrapolate=false) const
InterestRate | forwardRate (Time t1, Time t2, Compounding comp, Frequency freq=Annual, bool extrapolate=false) const
Jump inspectors
const std::vector< Date > & | jumpDates () const
const std::vector< Time > & | jumpTimes () const
Observer interface
void | update ()
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~TermStructure ()
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Date | maxDate () const =0
| the latest date for which the curve can return values
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled

## Calculations

This method must be implemented in derived classes to perform the actual calculations. When it is called, range check has already been performed; therefore, it must assume that extrapolation is required.
virtual DiscountFactor | discountImpl (Time) const =0
| discount factor calculation

## Additional Inherited Members

Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_

## Detailed Description

Interest-rate term structure.

This abstract class defines the interface of concrete interest rate structures which will be derived from this one.

Tests:
  observability against evaluation date changes is checked.

Examples
  FittedBondCurve.cpp.

## Constructor & Destructor Documentation

## YieldTermStructure()

QL_DEPRECATED YieldTermStructure | ( | const DayCounter & | dc,
|  | const std::vector< Handle< Quote > > & | jumps,
|  | const std::vector< Date > & | jumpDates = `std::vector< Date >()`
| ) |  |

Deprecated:
  Passing jumps without a reference date never worked correctly. Use one of the other constructors instead. Deprecated in version 1.19.

## Member Function Documentation

## discount()

DiscountFactor discount | ( | Time | t,
|  | bool | extrapolate = `false`
| ) |  | const

The same day-counting rule used by the term structure should be used for calculating the passed time t.

## zeroRate() [1/2]

InterestRate zeroRate | ( | const Date & | d,
|  | const DayCounter & | resultDayCounter,
|  | Compounding | comp,
|  | Frequency | freq = `Annual`,
|  | bool | extrapolate = `false`
| ) |  | const

The resulting interest rate has the required daycounting rule.

## zeroRate() [2/2]

InterestRate zeroRate | ( | Time | t,
|  | Compounding | comp,
|  | Frequency | freq = `Annual`,
|  | bool | extrapolate = `false`
| ) |  | const

The resulting interest rate has the same day-counting rule used by the term structure. The same rule should be used for calculating the passed time t.

## forwardRate() [1/3]

InterestRate forwardRate | ( | const Date & | d1,
|  | const Date & | d2,
|  | const DayCounter & | resultDayCounter,
|  | Compounding | comp,
|  | Frequency | freq = `Annual`,
|  | bool | extrapolate = `false`
| ) |  | const

The resulting interest rate has the required day-counting rule.

## forwardRate() [2/3]

InterestRate forwardRate | ( | const Date & | d,
|  | const Period & | p,
|  | const DayCounter & | resultDayCounter,
|  | Compounding | comp,
|  | Frequency | freq = `Annual`,
|  | bool | extrapolate = `false`
| ) |  | const

The resulting interest rate has the required day-counting rule.

Warning:
  dates are not adjusted for holidays

## forwardRate() [3/3]

InterestRate forwardRate | ( | Time | t1,
|  | Time | t2,
|  | Compounding | comp,
|  | Frequency | freq = `Annual`,
|  | bool | extrapolate = `false`
| ) |  | const

The resulting interest rate has the same day-counting rule used by the term structure. The same rule should be used for calculating the passed times t1 and t2.

## update()

void update | ( |  | ) |

virtual

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Reimplemented from TermStructure.